/*
 * Copyright (c) 2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *    * Redistributions of source code must retain the above copyright
 *      notice, this list of conditions and the following disclaimer.
 *
 *    * Redistributions in binary form must reproduce the above
 *      copyright notice, this list of conditions and the following
 *      disclaimer in the documentation and/or other materials provided
 *      with the distribution.
 *
 *    * Neither the name of The Linux Foundation nor the names of its
 *      contributors may be used to endorse or promote products derived
 *      from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */

#ifndef SOC_IACC_H_
#define SOC_IACC_H_

#define _IACC_REG_BASE							0x10D01000

#define A7DA_IACC_INTCODECCTL_MODE_CTRL			(_IACC_REG_BASE + 0x0)
#define A7DA_IACC_INTCODECCTL_TX_RX_EN			(_IACC_REG_BASE + 0x04)

#define A7DA_IACC_INTCODECCTL_TXFIFO0_OP		(_IACC_REG_BASE + 0x40)
#define A7DA_IACC_INTCODECCTL_TXFIFO0_LEV_CHK	(_IACC_REG_BASE + 0x44)
#define A7DA_IACC_INTCODECCTL_TXFIFO0_STS		(_IACC_REG_BASE + 0X48)
#define A7DA_IACC_INTCODECCTL_TXFIFO0_INT		(_IACC_REG_BASE + 0x4C)
#define A7DA_IACC_INTCODECCTL_TXFIFO0_INT_MSK	(_IACC_REG_BASE + 0x50)

#define A7DA_IACC_INTCODECCTL_TXFIFO1_OP		(_IACC_REG_BASE + 0x54)
#define A7DA_IACC_INTCODECCTL_TXFIFO1_LEV_CHK	(_IACC_REG_BASE + 0x58)
#define A7DA_IACC_INTCODECCTL_TXFIFO1_STS		(_IACC_REG_BASE + 0X5C)
#define A7DA_IACC_INTCODECCTL_TXFIFO1_INT		(_IACC_REG_BASE + 0x60)
#define A7DA_IACC_INTCODECCTL_TXFIFO1_INT_MSK	(_IACC_REG_BASE + 0x64)

#define A7DA_IACC_INTCODECCTL_TXFIFO2_OP		(_IACC_REG_BASE + 0x68)
#define A7DA_IACC_INTCODECCTL_TXFIFO2_LEV_CHK	(_IACC_REG_BASE + 0x6C)
#define A7DA_IACC_INTCODECCTL_TXFIFO2_STS		(_IACC_REG_BASE + 0X70)
#define A7DA_IACC_INTCODECCTL_TXFIFO2_INT		(_IACC_REG_BASE + 0x74)
#define A7DA_IACC_INTCODECCTL_TXFIFO2_INT_MSK	(_IACC_REG_BASE + 0x78)

#define A7DA_IACC_INTCODECCTL_TXFIFO3_OP		(_IACC_REG_BASE + 0x7C)
#define A7DA_IACC_INTCODECCTL_TXFIFO3_LEV_CHK	(_IACC_REG_BASE + 0x80)
#define A7DA_IACC_INTCODECCTL_TXFIFO3_STS		(_IACC_REG_BASE + 0X84)
#define A7DA_IACC_INTCODECCTL_TXFIFO3_INT		(_IACC_REG_BASE + 0x88)
#define A7DA_IACC_INTCODECCTL_TXFIFO3_INT_MSK	(_IACC_REG_BASE + 0x78)

#define A7DA_IACC_INTCODECCTL_RXFIFO0_OP		(_IACC_REG_BASE + 0xB8)
#define A7DA_IACC_INTCODECCTL_RXFIFO0_LEV_CHK	(_IACC_REG_BASE + 0xBC)
#define A7DA_IACC_INTCODECCTL_RXFIFO0_STS		(_IACC_REG_BASE + 0XC0)
#define A7DA_IACC_INTCODECCTL_RXFIFO0_INT		(_IACC_REG_BASE + 0xC4)
#define A7DA_IACC_INTCODECCTL_RXFIFO0_INT_MSK	(_IACC_REG_BASE + 0xC8)

#define A7DA_IACC_INTCODECCTL_RXFIFO1_OP		(_IACC_REG_BASE + 0xCC)
#define A7DA_IACC_INTCODECCTL_RXFIFO1_LEV_CHK	(_IACC_REG_BASE + 0xD0)
#define A7DA_IACC_INTCODECCTL_RXFIFO1_STS		(_IACC_REG_BASE + 0XD4)
#define A7DA_IACC_INTCODECCTL_RXFIFO1_INT		(_IACC_REG_BASE + 0xD8)
#define A7DA_IACC_INTCODECCTL_RXFIFO1_INT_MSK	(_IACC_REG_BASE + 0xDC)

#define A7DA_IACC_INTCODECCTL_RXFIFO2_OP		(_IACC_REG_BASE + 0xE0)
#define A7DA_IACC_INTCODECCTL_RXFIFO2_LEV_CHK	(_IACC_REG_BASE + 0xE4)
#define A7DA_IACC_INTCODECCTL_RXFIFO2_STS		(_IACC_REG_BASE + 0XE8)
#define A7DA_IACC_INTCODECCTL_RXFIFO2_INT		(_IACC_REG_BASE + 0xEC)
#define A7DA_IACC_INTCODECCTL_RXFIFO2_INT_MSK	(_IACC_REG_BASE + 0xF0)

#define TX_24BIT								1
#define RX_24BIT								(1 << 1)
#define RX0_24BIT								(1 << 1)
#define TX_START_SYNC_EN						(1 << 2)
#define TX_SYNC_EN								(1 << 3)
#define RX1_24BIT								(1 << 4)
#define RX2_24BIT								(1 << 5)
#define RX3_24BIT								(1 << 6)
#define RX_SYNC_TIMEOUT_BIT_MASK				(0xFFF << 16)

#define DAC_EN									1
#define DAC0_EN									1
#define DAC1_EN									(1 << 1)
#define DAC2_EN									(1 << 2)
#define DAC3_EN									(1 << 3)

#define ADC_EN									(1 << 8)
#define ADC0_EN									(1 << 8)
#define ADC1_EN									(1 << 9)
#define ADC2_EN									(1 << 10)
#define ADC3_EN									(1 << 11)

#define RX_DMA_CTRL_MASK						(0xF << 8)
#define RX_DMA_CTRL_SHIFT						8

#define RX_DMA_SYNC_EN_MASK						(1 << 4)
#define RX_DMA_SYNC_EN_SHIFT					4

#define FIFO_START								1
#define FIFO_RESET								(1 << 1)

#define FIFO_LEV_CHECK_STOP_MASK				0x1F
#define FIFO_LEV_CHECK_LOW_MASK					(0x1F << 10)
#define FIFO_LEV_CHECK_HIGH_MASK				(0x1F << 20)

#endif /* SOC_IACC_H_ */
